﻿
using System;
using Wisej.Web;

namespace Wisej.CustomColumnEditor
{
	public partial class AddressEditor : Form
	{
		public AddressEditor()
		{
			InitializeComponent();

			// Workaround for WJ-7514.
			Eval("this.focus = function(){}");
		}

		public string Value
		{
			get
			{
				var value = String.Format("{0}, {1} {2}, {3}", this.txtAddress.Text, this.txtCity.Text, this.cmbState.Text, this.txtZIP.Text);

				// Workaround for WJ-7515.
				value = value.ToUpper();

				return value;
			}
			set
			{
				this.txtAddress.Text = "";
				this.txtCity.Text = "";
				this.cmbState.Text = "";
				this.txtZIP.Text = "";

				var parts = value.Split(',');
				for (var i=0; i < parts.Length; i++)
				{
					switch (i)
					{
						case 0: // address
							this.txtAddress.Text = parts[0].Trim();
							break;

						case 1: // city state
							var cityState = parts[1].Trim().Split(' ');
							if (cityState.Length > 0)
								this.txtCity.Text = cityState[0].Trim();
							if (cityState.Length > 1)
								this.cmbState.Text = cityState[1].Trim();
							break;

						case 2: // ZIP
							this.txtZIP.Text = parts[2].Trim();
							break;
					}
				}
			}
		}

		private void buttonOK_Click(object sender, EventArgs e)
		{
			// TODO: Validate

			Close();
		}

		private void buttonCancel_Click(object sender, EventArgs e)
		{
			Close();
		}
	}
}
