﻿using System;
using Wisej.Web;


namespace Wisej.CustomColumnEditor
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			this.dataGridView1.RowCount = 100;
		}

		private void dataGridView1_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
		{
			var grid = (DataGridView)sender;
			var cell = grid.CurrentCell;
			var column = cell.OwningColumn;

			if (e.ColumnIndex == 0)
			{
				// create it the first time only.
				var editor = column.Editor ?? new DummyEditor();
				column.Editor = editor;
				editor.Text = cell.GetEditedFormattedValue();
			}
			else if (e.ColumnIndex == 1)
			{
				// create the editor every time, the form is disposed when closed.
				var editor = new AddressEditor();
				column.Editor = editor;
				var addressEditor = (AddressEditor)editor;
				addressEditor.Value = cell.GetEditedFormattedValue();
			}
		}

		private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
		{
			var grid = (DataGridView)sender;
			var cell = grid.CurrentCell;
			var column = cell.OwningColumn;

			if (e.ColumnIndex == 0)
			{
				// save the value back to the cell.
				cell.Value = column.Editor.Text;
			}
			else if (e.ColumnIndex == 1)
			{
				// save the value back to the cell.
				var addressEditor = (AddressEditor)column.Editor;
				cell.Value = addressEditor.Value;
			}
		}
	}
}
